from distutils.core import setup, Command
from distutils.extension import Extension
from distutils.command.build_py import build_py as _build_py
from unittest import TextTestRunner, TestLoader

import sys
import os

class build_py(_build_py):
  if os.system("python gen.py") != 0:
    sys.exit(1)

class TestCommand(Command):
  user_options = [ ]
  def initialize_options(self):
    pass
  def finalize_options(self):
    pass
  def run(self):
    for testfile in ['test']:
      tests = TestLoader().loadTestsFromNames(['test', 'test_star'])
      t = TextTestRunner(verbosity = 99)
      t.run(tests)

opencv_root = os.environ['OPENCV_ROOT']
from distutils.core import setup, Extension
setup(name='cv',
      author = 'James Bowman',
      author_email = 'jamesb@willowgarage.com',
      version='0.0.1',
      cmdclass = {'build_py': build_py, 'test': TestCommand},
      ext_modules=[ 
        Extension('cv',
                  ['toycv.cpp'],
                  depends=['api', 'defs', 'gen.py'],
                  include_dirs=[opencv_root + '/include'],
                  library_dirs=[opencv_root + '/lib'],
                  libraries=['cvaux', 'cv', 'cxcore', 'highgui', 'ml'],
                  # -Wl,-rpath,${prefix}/opencv/lib
                  undef_macros=['NDEBUG'],
                  extra_compile_args=['-g'])
      ],
)
